#include <SoftwareSerial.h>

#define coilPin 3
#define dimPin 0
#define analogFeedbackPin 1
#define countTop 40

#define RX    4   // *** D3, Pin 2
#define TX    3   // *** D4, Pin 3

#define voltageTarget 475

boolean controlMode = 0;

const byte sine_table[] = {255, 254, 246, 234, 218, 199, 177, 153, 127, 103, 79, 57, 37, 22, 10, 2, 0};
boolean state = 0;
byte possition = 0;
int count = countTop;

SoftwareSerial softSerial(RX, TX);

void setup() {
  softSerial.begin(1200);
  pinMode(coilPin, OUTPUT);
  pinMode(dimPin, OUTPUT);
  softSerial.println("init finisched");
}

void loop() {
  //turn on and off to drive the coil
  if(analogRead(analogFeedbackPin)<voltageTarget) digitalWrite(coilPin, HIGH);
  //delay(2);
  nonBlockingDelay(2000);
  digitalWrite(coilPin, LOW);
  //delay(2);
  nonBlockingDelay(2000);



  if (!controlMode) {


    if (softSerial.available()) {
      if (softSerial.read() == '.') controlMode = 1;
      //softSerial.println("cotrolmod activated");
    }


    //dim the diming pin
    if (count != 0 ) {
      count--;
    } else {
      if (possition < 16 && state == 0) { //fade out
        analogWrite(dimPin, sine_table[possition++]);
      }
      if (possition > 0 && state == 1) { //fade in
        analogWrite(dimPin, sine_table[possition--]);
      }
      if (possition == 0 || possition == 16) { //switch between fade out and in
        analogWrite(dimPin, sine_table[possition]);
        state = !state;
      }
      count = countTop;
    }
  } else {


    if (softSerial.available() ) {
      analogWrite(dimPin, (uint8_t)softSerial.read());
    }
  }

}

void nonBlockingDelay(long mic){
  long microsOld=micros();
  while(microsOld+mic>micros());
  }
